Unit IAC1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAC1R1_p, IAC1R2_p, IAC1R3_p, IAC1R4_p;

procedure IAC1R(var X :Array of Real; NX :Integer;
                var FX :Array of Real; LX :Integer;
                MXA :Integer; FXA :Real; MXB :Integer;
                FXB :Real; var TX :Array of Real;
                var CX :Array of Real);

implementation

procedure IAC1R(var X :Array of Real; NX :Integer;
                var FX :Array of Real; LX :Integer;
                MXA :Integer; FXA :Real; MXB :Integer;
                FXB :Real; var TX :Array of Real;
                var CX :Array of Real);
var
I,J,K :Integer;
A :Array [0..2] of Real;
B :Array [0..2] of Real;
const
K1 :Integer = 1;
K2 :Integer = 2;
K3 :Integer = 3;
label
_10,_20,_30,_40,_50;
begin
IAC1R2(X,NX,MXA,TX);
if ( MXA  <  K3 ) 
 then goto _10;
I  := NX - K2;
CX[K1-1] := FX[I-1];
I  := I + K1;
CX[K2-1] := FX[I-1];
I  := NX + K2 + K1;
CX[I-1] := FX[K2-1];
I  := I + K1;
CX[I-1] := FX[K3-1];
goto _20;
_10:
IAC1R3(TX,NX,CX,LX,MXA,MXB,A,B);
_20:
for I:=K1 to NX do
 begin
  J  := I + K2;
  CX[J-1] := FX[I-1];
_30:
 end;
if ( MXA  >  K2 ) 
 then goto _40;
IAC1R4(TX,NX,CX,LX,MXA,FXA,MXB,FXB,A,B);
_40:
I  := NX + K2;
for J:=K1 to I do
 begin
  K  := J + K1;
  CX[J-1] := IAC1R1(TX,CX,LX,K);
_50:
 end;
end;

end.
